/*****************************************************************************

		Copyright (c) 1984 - 2000 Prolog Development Center A/S

 Project:  SEN_AN
 FileName: SEN_AN.PRO
 Purpose: No description
 Written by: Visual Prolog
 Comments:
******************************************************************************/


facts - senan_db 				
  det(string)
  noun(string)
  rel(string)
  verb(string)

domains						
  DETERM	= none;
  		  determ(string)
  NOUNP		= nounp(DETERM,string,RELCL)
  RELCL		= none;
  		  relcl(string,VERBP)
  SENTENCE	= sent(NOUNP,VERBP)
  VERBP		=verb(string);
		  verbp(string,NOUNP)
  TOKL		= string*

  			

predicates					
% Recognition of words in different forms
  is_det(string)
  is_noun(string)
  is_rel(string)
  is_verb(string)

% Parser
  nondeterm s_determ(TOKL,TOKL,TOKL,TOKL,DETERM)
  nondeterm s_nounp(TOKL,TOKL,TOKL,TOKL,NOUNP)
  nondeterm s_relcl(TOKL,TOKL,TOKL,TOKL,RELCL)
  nondeterm s_sentence(TOKL,TOKL,TOKL,TOKL,SENTENCE)
  nondeterm s_verbp(TOKL,TOKL,TOKL,TOKL,VERBP)


% scanner
  check(string)
  tokl(string,TOKL)
  str(TOKL,string,string)
  plus(TOKL,TOKL,TOKL)
  
  
clauses						
						


  s_sentence(TOKL,TOKL2,TOKL0,TOKLF,sent(NOUNP,VERBP)):- 	
	s_nounp(TOKL,TOKL1,TOKL0,TOKL01,NOUNP),		
	s_verbp(TOKL1,TOKL2,TOKL01,TOKLF,VERBP),		
	TOKL2=[],				
	!.					
  s_sentence(_,_,_,_,_):-
	write(">> Sentence not recognized\n"),	
	fail.

  s_nounp(TOKL,TOKL2,TOKL0,TOKLF,nounp(DETERM,NOUN,RELCL)):-
	s_determ(TOKL,[NOUN|TOKL1],TOKL0,TOKL01,DETERM),	
	is_noun(NOUN),
	s_relcl(TOKL1,TOKL2,[NOUN|TOKL01],TOKLF,RELCL).		

  s_determ([DET|TOKL],TOKL,TOKL0,[DET|TOKL0],determ(DET)):- 
	is_det(DET).
	
  s_determ([NOUN|TOKL],[NOUN|TOKL],TOKL0,[STR2|TOKL0],determ(STR2)):-
  	is_noun(NOUN),
  	write("Please write a determination to the noun ", NOUN, ": "),
  	readln(STR2),
  	not(str_len(STR2, 0)),
  	check(STR2),
  	is_det(STR2).
  
 s_determ(TOKL,TOKL,TOKL0,TOKL0,none).
  				

  s_relcl([REL|TOKL],TOKL1,TOKL0,TOKLF,relcl(REL,VERBP)):-	
	is_rel(REL),
	s_verbp(TOKL,TOKL1,[REL|TOKL0],TOKLF,VERBP).
  s_relcl(TOKL,TOKL,[NOUN|TOKL0],TOKLF,relcl(REL,VERBP)):-
  	write("Please write a relative clause to the noun ", NOUN, ": "),
  	readln(STR2),
  	not(str_len(STR2, 0)),
  	tokl(STR2,[REL|TOKLR]),
  	is_rel(REL),
  	s_verbp(TOKLR,TOKLR1,[REL],TOKLRF,VERBP),
  	TOKLR1=[],
  	plus(TOKLRF,[],TOKLRFC),
  	plus(TOKLRFC,[NOUN|TOKL0],TOKLF).
  s_relcl(TOKL,TOKL,TOKL0,TOKL0,none).			

  s_verbp([VERB|TOKL],TOKL1,TOKL0,TOKLF,verbp(VERB,NOUNP)):-
	is_verb(VERB),
	s_nounp(TOKL,TOKL1,[VERB|TOKL0],TOKLF,NOUNP).		
  s_verbp([VERB|TOKL],TOKL,TOKL0,[VERB|TOKL0],verb(VERB)):-	
	is_verb(VERB).

 
  is_noun(X):-										
	noun(X),			
	!.				
  is_noun(X):-				
	noun(Y),			
	concat(Y,"s",X),
	!.

  is_det(X):-				
	det(X),
	!.

  is_rel(X):-				
	rel(X),
	!.

  is_verb(X):-				
	verb(X),
	!.
  is_verb(X):-				
	verb(Y),
	concat(Y,"s",X),
	!.
  is_verb(X):- 
	verb(Y),
	concat(Y,"ed",X),
	!.
  is_verb(X):-
	verb(Y),
	concat(Y,"es",X),
	!.
  is_verb(X):-
	verb(Y),
	concat(Y,"ing",X),
	!.

  tokl(STR,[TOK|TOKL]):-		
  	fronttoken(STR,TOK,STR1),	
	check(TOK),			
	!,				
	tokl(STR1,TOKL).		
  tokl(_,[]).	
  
  str([TOK|TOKL],MES0,MES):-
  	fronttoken(MES1,TOK,MES0),
  	concat(" ",MES1,MES2),
  	not(TOKL=[]),
  	!,
  	str(TOKL,MES2,MES).
  str([TOK|TOKL],MES2,MES):-
    	fronttoken(MES,TOK,MES2).
    	
  plus([TOK|TOKL],TOKL0,TOKLF):-
  	not(TOKL=[]),
  	!,
  	plus(TOKL,[TOK|TOKL0],TOKLF).
  plus([TOK|TOKL],TOKL0,[TOK|TOKL0]).
  	
  check(WORD):-				
	is_noun(WORD),
	!.				
  check(WORD):-
	is_det(WORD),
	!.
  check(WORD):-
	is_rel(WORD),
	!.
  check(WORD):-
	is_verb(WORD),
	!.
  check(WORD):-				
	write(">> Unknown word: ",WORD),
	nl.

goal	
  consult("sen_an.dba",senan_db),			
  write("Try: man that lives loves woman\n"),	
  write("Write a sentence: "),				
  readln(STR),						
  tokl(STR,TOKL),
  s_sentence(TOKL, RESTTOKL,[],TOKLF,SENT),			
  RESTTOKL=[],
  str(TOKLF,"",MES),
  write(MES,"\n"),
  write(SENT).
 				
